<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <div>
    <!-- Hero -->
    <v-container class="landing-hero">
      <v-row class="landing-hero-row text-center text-md-left" no-gutters justify="center" justify-sm="start">
        <!-- Text -->
        <v-col class="landing-hero-text" cols="12" sm="12" md="6">
          <!-- Potential Login Error -->
          <transition name="slide-y-transition" mode="out-in">
            <v-alert v-show="authError" class="landing-hero-error studium-alert" dense text type="error">
              {{ authError }}
            </v-alert>
          </transition>

          <!-- Tagline & Book Tower -->
          <v-row>
            <v-col class="landing-hero-tagline"> {{ $t('landing.title') }} </v-col>
          </v-row>

          <!-- Description -->
          <v-row>
            <v-col class="landing-hero-description">
              {{ $t('landing.description') }}
            </v-col>
          </v-row>

          <!-- Buttons -->
          <v-row>
            <v-col>
              <!-- Login -->
              <login-button class="ma-1" />

              <!-- Learn more -->
              <v-btn class="ma-1 studium-button" color="secondary" text outlined large :ripple="false" to="/about">
                {{ $t('landing.more') }}
              </v-btn>
            </v-col>
          </v-row>
        </v-col>

        <!-- Skeleton -->
        <v-col cols="12" md="auto">
          <skeleton-hero class="landing-hero-skeleton" />
        </v-col>
      </v-row>
    </v-container>

    <!-- Bottom -->
    <v-container class="px-4 px-lg-0">
      <!-- What's so special? -->
      <v-row class="landing-features mt-15 mt-md-0" align="center" justify="center">
        <v-col cols="12" align="center">
          <h2 class="landing-segment-title">{{ $t('landing.special') }}</h2>
        </v-col>

        <!-- Personalised Dashboard -->
        <v-col class="pa-4" cols="12" sm="7" md="5" lg="4" align="center">
          <img id="feature-card-1" src="~/assets/img/landing/feature-card-1.svg" alt="Personalised Dashboard" />
        </v-col>

        <!-- Super Easy -->
        <v-col class="pa-4" cols="12" sm="7" md="5" lg="4" align="center">
          <img id="feature-card-2" src="~/assets/img/landing/feature-card-2.svg" alt="Super easy" />
        </v-col>

        <!-- Stay Up to Date -->
        <v-col class="pa-4" cols="12" sm="7" md="5" lg="4" align="center">
          <img id="feature-card-3" src="~/assets/img/landing/feature-card-3.svg" alt="Stay up to date" />
        </v-col>
      </v-row>

      <!-- Need to know more? -->
      <v-row class="landing-bullets px-5 px-md-0 align-center mb-15">
        <v-col lg="6" class="d-none d-lg-inline">
          <skeleton-bullets />
        </v-col>

        <v-col cols="12" lg="6">
          <v-row class="mb-4 justify-center justify-lg-start">
            <p id="segment-bullets" class="landing-segment-title ml-0 ml-lg-6">{{ $t('landing.know') }}</p>
          </v-row>

          <!-- Bullet Points -->
          <v-row class="justify-center justify-lg-start">
            <ul>
              <li class="landing-bullet-point">
                <p class="ml-0 ml-lg-1">{{ $t('landing.free') }}</p>
              </li>
              <li class="landing-bullet-point">
                <p class="ml-0 ml-lg-1">{{ $t('landing.lang') }}</p>
              </li>
              <li class="landing-bullet-point">
                <p class="ml-0 ml-lg-2">{{ $t('landing.available') }}</p>
              </li>
              <li class="landing-bullet-point">
                <p class="ml-0 ml-lg-2">{{ $t('landing.features') }}</p>
              </li>
            </ul>
          </v-row>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, onMounted, useContext, useMeta } from '@nuxtjs/composition-api'
import { gsap } from 'gsap'
import { ScrollTrigger } from 'gsap/ScrollTrigger'

import seo from '~/seo.config'
import { handleError } from '~/util/composables'

export default defineComponent({
  auth: 'guest',
  setup() {
    const context = useContext()

    // Potential authentication error
    const authError = computed(() => handleError(context.$auth.error, context)?.message)

    gsap.registerPlugin(ScrollTrigger)

    onMounted(() => {
      // Bullet point animation
      const tlBullets = gsap.timeline({
        defaults: { duration: 0.25 },
        scrollTrigger: {
          trigger: '#segment-bullets',
          toggleActions: 'play none none none',
          start: 'top 60%',
        },
      })

      tlBullets.set('.landing-bullet-point', { visibility: 'visible' })
      tlBullets.from('.landing-bullet-point', { y: 30, opacity: 0, stagger: 0.4 })

      // Feature card animations
      function getFeatureCardScrollTrigger(name) {
        return {
          scrollTrigger: {
            trigger: name,
            toggleActions: 'play none none none',
            start: 'top 60%',
          },
          opacity: 0,
          x: -200,
          duration: 1,
        }
      }

      gsap.from('#feature-card-1', getFeatureCardScrollTrigger('#feature-card-1'))
      gsap.from('#feature-card-2', getFeatureCardScrollTrigger('#feature-card-2'))
      gsap.from('#feature-card-3', getFeatureCardScrollTrigger('#feature-card-3'))
    })

    // SEO
    useMeta(() => ({
      titleTemplate: `${seo.name} - ${seo.tagline}`,
    }))

    return { authError }
  },

  // Empty head for useMeta
  head: {},
})
</script>

<style lang="scss" scoped>
.landing {
  position: relative;

  &-hero {
    $hero-height: max(500px, calc(100vh - 100px));

    height: $hero-height;

    &-text {
      margin-top: 15vh;

      @media #{map-get($display-breakpoints, 'xs-only')} {
        margin-top: 10vh;
      }
    }

    &-error {
      margin-top: -56px;
      text-align: left;
    }

    &-tagline {
      $font-size: 4rem;
      font-size: $font-size;
      font-weight: 500;
      font-style: normal;
      line-height: 1.25 * $font-size;
      color: $primary;

      @media #{map-get($display-breakpoints, 'md-and-down')} {
        $font-size: 3.25rem;
        font-size: $font-size;
        line-height: 1.25 * $font-size;
      }

      @media #{map-get($display-breakpoints, 'sm-and-down')} {
        $font-size: 3rem;
        font-size: $font-size;
        line-height: 1.25 * $font-size;
        text-align: center;
      }

      @media #{map-get($display-breakpoints, 'xs-only')} {
        $font-size: 2.2rem;
        font-size: $font-size;
        line-height: 1.25 * $font-size;
      }
    }

    &-description {
      $font-size: 1.5rem;
      font-size: $font-size;
      line-height: 1.25 * $font-size;
      color: $secondary;

      @media #{map-get($display-breakpoints, 'xs-only')} {
        $font-size: 1.2rem;
        font-size: $font-size;
        line-height: 1.25 * $font-size;
      }
    }

    &-skeleton {
      position: absolute;

      ::v-deep svg {
        max-height: $hero-height;
      }

      @media #{map-get($display-breakpoints, 'sm-and-down')} {
        display: none;
      }

      @media #{map-get($display-breakpoints, 'lg-and-up')} {
        right: 0;
        left: auto;
      }
    }

    // When screen height is too narrow
    @media (max-height: 700px) {
      &-text {
        margin-top: 2vh;
      }
    }

    // Special tablet layout
    @media #{map-get($display-breakpoints, 'sm-and-down')} and (min-height: 700px) {
      overflow: hidden;

      &-text {
        margin-top: 5vh;
      }

      &-skeleton {
        display: block !important;
        position: relative;
        margin-top: 5vh;

        ::v-deep svg {
          width: 100vw;
        }
      }
    }
  }

  &-segment-title {
    color: $primary;
    font-size: 2.5rem;
    font-weight: 500;

    @media #{map-get($display-breakpoints, 'sm-and-down')} {
      text-align: center;
      font-size: 1.5rem;
    }

    @media #{map-get($display-breakpoints, 'md-and-down')} {
      font-size: 2rem;
    }
  }

  &-bullets {
    margin-top: 10vh;

    @media #{map-get($display-breakpoints, 'lg-and-up')} {
      margin-top: 20vh;
    }

    ul {
      list-style-type: none;
      margin-left: 16px;
    }

    li {
      list-style-image: url('~/assets/img/landing/polygon.svg');
    }
  }

  &-bullet-point {
    p {
      margin-bottom: 3vh;
      font-size: 1.5rem;
      font-weight: 500;
      color: #111b47;

      @media #{map-get($display-breakpoints, 'sm-and-down')} {
        font-size: 1rem;
      }

      @media #{map-get($display-breakpoints, 'md-and-down')} {
        font-size: 1.25rem;
      }
    }
  }
}
</style>
